Bug 245456 - please add arm support to the gmp package
please add arm support to the gmp package
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: gmp (Show other bugs)
rawhide
arm9 Linux
low Severity low
: ---
: ---
Assigned To: Ivana Varekova
Fedora Extras Quality Assurance
: Reopened
Depends On:
Blocks: ARMTracker
  Show dependency treegraph
 
Reported: 2007-06-23 11:23 EDT by Lennert Buytenhek
Modified: 2007-11-30 17:12 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-08-07 10:08:39 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Spec file patch to set basearch to 'arm' on arm platforms. (400 bytes, patch)
2007-06-23 11:23 EDT, Lennert Buytenhek
no flags Details | Diff
Patch against gmp.h to include arm support. (311 bytes, patch)
2007-06-23 11:25 EDT, Lennert Buytenhek
no flags Details | Diff
Patch against gmp-mparam.h to include arm support. (353 bytes, patch)
2007-06-23 11:25 EDT, Lennert Buytenhek
no flags Details | Diff
Patch for gmp to fix ARM fp word order (no longer needed for gmp 4.2.) (1.18 KB, patch)
2007-06-23 11:29 EDT, Lennert Buytenhek
no flags Details | Diff

  None (edit)
Description Lennert Buytenhek 2007-06-23 11:23:19 EDT
gmp currently doesn't build on arm platforms.  There are two issues:

1. arm isn't included in the ifdef trees in gmp.h/gmp-mparam.h.

2. gmp 4.1.2 makes incorrect assumptions about the floating point format
   on ARM systems, causing the testsuite to fail.  This is no longer an
   issue in upstream gmp, as gmp version 4.2 has moved the mpfr bits to
   a separate package, but Fedora still ships version 4.1.

I've attached patches that fix the above issues.  Please consider
applying the patches for (1), and please either consider applying the
patch for (2) or re-base gmp to a newer upstream version.

Thanks for your time.
Comment 1 Lennert Buytenhek 2007-06-23 11:23:19 EDT
Created attachment 157684 [details]
Spec file patch to set basearch to 'arm' on arm platforms.
Comment 2 Lennert Buytenhek 2007-06-23 11:25:02 EDT
Created attachment 157685 [details]
Patch against gmp.h to include arm support.
Comment 3 Lennert Buytenhek 2007-06-23 11:25:52 EDT
Created attachment 157686 [details]
Patch against gmp-mparam.h to include arm support.
Comment 4 Lennert Buytenhek 2007-06-23 11:29:31 EDT
Created attachment 157687 [details]
Patch for gmp to fix ARM fp word order (no longer needed for gmp 4.2.)

To understand this patch, note that there are three different
'double' formats on ARM systems:

1. Big-endian ARM systems, both old-ABI and EABI: big endian byte
   order, big endian word order.

2. Little-endian old-ABI ARM systems: little endian byte order,
   big endian word order.

3. Little-endian EABI ARM systems: little endian byte order, little
   endian word order.
Comment 5 Ivana Varekova 2007-08-07 07:59:51 EDT
Hello, 
now the actual version of gmp in Fedora is 4.2.1 so the second problem is fixed.
However the first part of this bug (including arm in ifdef parts) should be
fixed in the upstream version so everyone (not only FC users) could use it.
Could you please sent this patch to upstream maintainers (http://gmplib.org)? If
there is any problem please write here a comment.
Comment 6 Lennert Buytenhek 2007-08-07 08:24:04 EDT
Hello,

gmp.h and gmp-mparam.h are Fedora additions, not part of upstream gmp.

Also, the gmp.spec spec file that I submitted a patch for lives in
Fedora CVS only, and is not part of the upstream gmp distribution.


From gmp.h:

/*
 * This gmp.h is a wrapper include file for the original gmp.h, which has been
 * renamed to gmp-<arch>.h. There are conflicts for the original gmp.h on
 * multilib systems, which result from arch-specific configuration options.
 * Please do not use the arch-specific file directly.
 *
 * Copyright (C) 2006 Red Hat, Inc.
 * Thomas Woerner <twoerner@@redhat.com>
 */
Comment 7 Ivana Varekova 2007-08-07 10:08:39 EDT
Ops sorry, you are right. Fixed in gmp-4.2.1-2.fc8.

Note You need to log in before you can comment on or make changes to this bug.